package com.its.op.service.its.incident;

import com.its.op.dao.repository.its.incident.TbIncdEstmSectRepository;
import com.its.op.dto.its.incident.TbIncdEstmSectDto;
import com.its.op.entity.its.incident.TbIncdEstmSect;
import com.its.op.entity.its.incident.TbIncdEstmSectKey;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbIncdEstmSectService {

    private final TbIncdEstmSectRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbIncdEstmSect requireOne(TbIncdEstmSectKey id) throws NoSuchElementException {
        Optional<TbIncdEstmSect> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbIncdEstmSectDto> findAll() {
        List<TbIncdEstmSectDto> result = new ArrayList<>();
        List<TbIncdEstmSect> data = this.repo.findAll();
        for (TbIncdEstmSect entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbIncdEstmSectDto findById(TbIncdEstmSectKey id) {
        TbIncdEstmSect entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbIncdEstmSectDto updateById(TbIncdEstmSectKey id, TbIncdEstmSectDto.TbIncdEstmSectUpdReq req) {
        TbIncdEstmSect entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbIncdEstmSectDto> mergeInfoList(List<TbIncdEstmSectDto.TbIncdEstmSectUpdReq> reqList) {
        List<TbIncdEstmSectDto> result = new ArrayList<>();
        for (TbIncdEstmSectDto.TbIncdEstmSectUpdReq req : reqList) {
            TbIncdEstmSect obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbIncdEstmSectDto mergeInfo(TbIncdEstmSectDto.TbIncdEstmSectUpdReq req) {
        TbIncdEstmSect obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbIncdEstmSectDto deleteById(TbIncdEstmSectKey id) {
        TbIncdEstmSect entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbIncdEstmSectDto> deleteByIds(List<TbIncdEstmSectKey> ids) {
        List<TbIncdEstmSectDto> result = new ArrayList<>();
        for (TbIncdEstmSectKey id : ids) {
            Optional<TbIncdEstmSect> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
